# ------------------------------- Creo el despachador -------------------------------------------
set ns [new Simulator]

# -------------------------------- Trazas -------------------------------------------------------
set nam [open salida.nam w]
$ns namtrace-all $nam
set tf [open salida.out w]
$ns trace-all $tf

# ------------------------------- Creo la topología ---------------------------------------------
# Creo los nodos
set n1 [$ns node]
set n2 [$ns node]
set n3 [$ns node]
set n4 [$ns node]

# Creo los enlaces
# $ns duplex-link $n1 $n2 <anchoBanda> <retardo> <tipoCola>
$ns duplex-link $n1 $n2 1Mb 2ms DropTail
$ns duplex-link $n3 $n2 2Mb 2ms DropTail
$ns duplex-link $n2 $n4 2Mb 3ms DropTail

# -------------------------------- Tráfico -------------------------------------------------------
# ftp/tcp
set tcp [new Agent/TCP]
set tcpsink [new Agent/TCPSink]
$ns attach-agent $n3 $tcp
$ns attach-agent $n4 $tcpsink
$ns connect $tcp $tcpsink
set ftp [new Application/FTP]
$ftp attach-agent $tcp

# cbr/udp
set udp  [new Agent/UDP]
set null [new Agent/Null]
$ns attach-agent $n1 $udp
$ns attach-agent $n4 $null
$ns connect $udp $null
set cbr [new Application/Traffic/CBR]
$cbr attach-agent $udp
$cbr set packetSize_ 500 # tamaño de paquete bytes
$cbr set interval_ 0.005 # tiempo entre paquetes (seg)

# -------------------------------- Procedimientos -----------------------------------------------
proc fin {} {
    global ns tf nam
    puts "done!"
    $ns flush-trace
    close $tf
    close $nam
    exec nam salida.nam &
    exit 0 
}

# -------------------------------- Eventos -------------------------------------------------------
$ns at 0.5 "$cbr start"
$ns at 1.0 "$ftp start"
$ns at 4.0 "$cbr stop"
$ns at 4.5 "$ftp stop"
$ns at 5 "fin"

$ns run
